function MyAppGetHTMLElementsAtPoint(x,y) {
    var tags = "";
    var e;
    var offset = 0;
    while ((tags.search(",(A|IMG),") < 0) && (offset < 20)) {
        tags = ",";
        e = document.elementFromPoint(x,y+offset);
        while (e) {
            if (e.tagName) {
                tags += e.tagName + ',';
            }
            e = e.parentNode;
        }
        if (tags.search(",(A|IMG),") < 0) {
            e = document.elementFromPoint(x,y-offset);
            while (e) {
                if (e.tagName) {
                    tags += e.tagName + ',';
                }
                e = e.parentNode;
            }
        }
        
        offset++;
    }
    return tags;
}

function MyAppGetLinkSRCAtPoint(x,y) {
    var tags = "";
    var e = "";
    var offset = 0;
    while ((tags.length == 0) && (offset < 20)) {
        e = document.elementFromPoint(x,y+offset);
        while (e) {
            if (e.src) {
                tags += e.src;
                break;
            }
            e = e.parentNode;
        }
        if (tags.length == 0) {
            e = document.elementFromPoint(x,y-offset);
            while (e) {
                if (e.src) {
                    tags += e.src;
                    break;
                }
                e = e.parentNode;
            }
        }
        offset++;
    }
    return tags;
}

function MyAppGetLinkHREFAtPoint(x,y) {
    var tags = "";
    var e = "";
    var offset = 0;
    while ((tags.length == 0) && (offset < 20)) {
        e = document.elementFromPoint(x,y+offset);
        while (e) {
            if (e.href) {
                tags += e.href;
                break;
            }
            e = e.parentNode;
        }
        if (tags.length == 0) {
            e = document.elementFromPoint(x,y-offset);
            while (e) {
                if (e.href) {
                    tags += e.href;
                    break;
                }
                e = e.parentNode;
            }
        }
        offset++;
    }
    return tags;
}

function getPosition(x,y){
    var el = document.elementFromPoint(x,y);
    var pos = [el.offsetLeft, el.offsetTop];
    var parent = el.offsetParent;
    if (parent != el) {
        while (parent) {
            pos[0] += parent.offsetLeft;
            pos[1] += parent.offsetTop;
            parent = parent.offsetParent;
        }
    }
    return pos;
}

function MyAppGetImageSRCAtPoint(x,y) {
    var src = "";
    var imgs = document.getElementsByTagName('img');
    for (var i = 0; (i < imgs.length) && (src.length == 0); i++) {
        var el = imgs[i];
        var pos = [el.offsetLeft, el.offsetTop];
        var parent = el.offsetParent;
        if (parent != el) {
            while (parent) {
                pos[0] += parent.offsetLeft;
                pos[1] += parent.offsetTop;
                parent = parent.offsetParent;
            }
        }

        if ((x >= pos[0]) && (x <= (pos[0]+el.scrollWidth)) &&
            (y >= pos[1]) && (y <= (pos[1]+el.scrollHeight))) {
            src = el.src;
        }
    }
    
    return src;
}

function MyAppGetImageCaptionAtPoint(x,y) {
    var src = "";
    var imgs = document.getElementsByTagName('img');
    for (var i = 0; (i < imgs.length) && (src.length == 0); i++) {
        var el = imgs[i];
        var pos = [el.offsetLeft, el.offsetTop];
        var parent = el.offsetParent;
        if (parent != el) {
            while (parent) {
                pos[0] += parent.offsetLeft;
                pos[1] += parent.offsetTop;
                parent = parent.offsetParent;
            }
        }
        
        if ((x >= pos[0]) && (x <= (pos[0]+el.scrollWidth)) &&
            (y >= pos[1]) && (y <= (pos[1]+el.scrollHeight))) {
            src = el.title;
        }
    }
    
    return src;
}

function MyAppGetImageOriginalSRCAtPoint(x,y) {
    var src = "";
    var imgs = document.getElementsByTagName('img');
    for (var i = 0; (i < imgs.length) && (src.length == 0); i++) {
        var el = imgs[i];
        var pos = [el.offsetLeft, el.offsetTop];
        var parent = el.offsetParent;
        if (parent != el) {
            while (parent) {
                pos[0] += parent.offsetLeft;
                pos[1] += parent.offsetTop;
                parent = parent.offsetParent;
            }
        }
        
        if ((x >= pos[0]) && (x <= (pos[0]+el.scrollWidth)) &&
            (y >= pos[1]) && (y <= (pos[1]+el.scrollHeight))) {
            if(el.getAttribute('data-original-src')){
                src = el.getAttribute('data-original-src');
            }
        }
    }
    
    return src;
}

function offsetElement(element) {
    var rect = element.getBoundingClientRect();
    var docEl = doc.documentElement;
    return {
        left: rect.left + window.pageXOffset - docEl.clientLeft,
        top: rect.top + window.pageYOffset - docEl.clientTop,
        width: element.offsetWidth,
        height: element.offsetHeight
    };
}

function MyAppGetHREFAtPoint(x,y) {
    
    var docEl = document.documentElement;
    var href = "";
    var links = document.getElementsByTagName('a');
    for (var i = 0; (i < links.length) && (href.length == 0); i++) {
        var el = links[i];

        var rect = el.getBoundingClientRect();
        var left = rect.left + window.pageXOffset - docEl.clientLeft;
        var top = rect.top + window.pageYOffset - docEl.clientTop;
        var width = rect.right - rect.left;
        var height = rect.bottom - rect.top;
        if ((x >= left) && (x <= (left+width)) &&
            (y >= top) && (y <= (top+height))) {
            href = el.href;
        } else {
        }
    }
    
    return href;
}

function GetHTMLElementsAtPoint(x, y) {
    var tags = "";
    var elements = [];
    var display = [];
    var item = document.elementFromPoint(x, y);
    while (item && item !== document.body && item !== window && item !== document &&
           item !== document.documentElement) {
        elements.push(item);
        display.push(item.style.display);
        if (item.style.display != "none" && (item.tagName == 'A' || item.tagName == 'IMG')) {
            break;
        }
        item.style.display = "none";
        item = document.elementFromPoint(x, y);
    }
    
    if (elements.length > 0) {
        tags = ",";
        for (var i = 0; i < elements.length; i++) {
            elements[i].style.display = display[i];
            if (elements[i].tagName) {
                tags += elements[i].tagName + ',';
            }
        }
    }
    
    return tags;
}

function GetLinkSRCAtPoint(x,y) {
    var tags = "";
    var elements = [];
    var display = [];
    var item = document.elementFromPoint(x, y);
    while (item && item !== document.body && item !== window && item !== document &&
           item !== document.documentElement) {
        elements.push(item);
        display.push(item.style.display);
        if (item.style.display != "none" && (item.tagName == 'A' || item.tagName == 'IMG')) {
            break;
        }
        item.style.display = "none";
        item = document.elementFromPoint(x, y);
    }
    
    if (elements.length > 0) {
        for (var i = 0; i < elements.length; i++) {
            elements[i].style.display = display[i];
            if (display[i] != "none" && (elements[i].tagName == 'A' || elements[i].tagName == 'IMG') && elements[i].src) {
                tags += elements[i].src;
            }
        }
    }
    return tags;
}

function GetLinkHREFAtPoint(x,y) {
    var tags = "";
    var elements = [];
    var display = [];
    var item = document.elementFromPoint(x, y);
    while (item && item !== document.body && item !== window && item !== document &&
           item !== document.documentElement) {
        elements.push(item);
        display.push(item.style.display);
        if (item.style.display != "none" && (item.tagName == 'A' || item.tagName == 'IMG')) {
            break;
        }
        item.style.display = "none";
        item = document.elementFromPoint(x, y);
    }
    
    if (elements.length > 0) {
        for (var i = 0; i < elements.length; i++) {
            elements[i].style.display = display[i];
            if (display[i] != "none" && (elements[i].tagName == 'A' || elements[i].tagName == 'IMG') && elements[i].href) {
                tags += elements[i].href;
            }
        }
    }
    return tags;
}

function getSelectedLink()
{
    var tags = "";
    return tags;
}

function packFrames()
{
    if (document.readyState === 'complete')
    {
        var iframes = document.getElementsByTagName('iframe');
        for (i = 0; i < iframes.length; i++)
        {
            var iframe = iframes[i];
            if (iframe.src.includes('youtube.com/embed/') ||
                iframe.src.includes('player.vimeo.com/') ||
                iframe.src.includes('coub.com/') ||
                iframe.src.includes('vine.co/') ||
                iframe.src.includes('www.dailymotion.com/') ||
                iframe.src.includes('www.hulu.com/') ||
                iframe.src.includes('www.vube.com/') ||
                iframe.src.includes('www.netflix.com/') ||
                iframe.src.includes('www.liveleak.com/') ||
                iframe.src.includes('www.ustream.com/') ||
                iframe.src.includes('www.twitch.tv/') ||
                iframe.src.includes('player.twitch.tv/') ||
                iframe.src.includes('www.break.com/') ||
                iframe.src.includes('www.tv.com/') ||
                iframe.src.includes('www.metacafe.com/') ||
                iframe.src.includes('www.viewster.com/') ||
                iframe.src.includes('amp.twimg.com/v') ||
                iframe.src.includes('facebook.com/video')
                )
            {
                var div = document.createElement('div');
                div.classList.add('embed-responsive', 'embed-responsive-16by9');
                iframe.parentNode.insertBefore(div, iframe);
                div.appendChild(iframe);
            } else
            {
                iframe.style.maxWidth='100%';
                iframe.style.height='auto';
            }
        }
    }
}

function reloadFrames()
{
    if (document.readyState === 'complete')
    {
        var iframes = document.getElementsByTagName('iframe');
        for (i = 0; i < iframes.length; i++)
        {
            var iframe = iframes[i];
            if (iframe.src.includes('youtube.com/embed/'))
            {
                 var url = iframe.src;
                 iframe.src = url;
            }
        }
    }
}

function get_selection_offset(element)
{
    var start = 0;
    var end = 0;
    var doc = element.ownerDocument || element.document;
    var win = doc.defaultView || doc.parentWindow;
    var sel;
    if (typeof win.getSelection != 'undefined')
    {
        sel = win.getSelection();
        if (sel.rangeCount > 0)
        {
            var range = win.getSelection().getRangeAt(0);
            var preCaretRange = range.cloneRange();
            preCaretRange.selectNodeContents(element);
            preCaretRange.setEnd(range.startContainer, range.startOffset);
            start = preCaretRange.toString().length;
            preCaretRange.setEnd(range.endContainer, range.endOffset);
            end = preCaretRange.toString().length;
        }
    } else if ((sel = doc.selection) && sel.type != 'Control')
    {
        var textRange = sel.createRange();
        var preCaretTextRange = doc.body.createTextRange();
        preCaretTextRange.moveToElementText(element);
        preCaretTextRange.setEndPoint('EndToStart', textRange);
        start = preCaretTextRange.text.length;
        preCaretTextRange.setEndPoint('EndToEnd', textRange);
        end = preCaretTextRange.text.length;
    }
    
    var selectedText = rangy.getSelection().toString().replace(/(\r\n|\n|\r|\t)/gm,' ');

    return { start: start, end: end, text: selectedText };
}

function set_selection_offset(containerEl, savedSel)
{
    var doc = containerEl.ownerDocument, win = doc.defaultView;
    var charIndex = 0, range = doc.createRange();
    range.setStart(containerEl, 0);
    range.collapse(true);
    var nodeStack = [containerEl], node, foundStart = false, stop = false;

    while (!stop && (node = nodeStack.pop()))
    {
        if (node.nodeType == 3)
        {
            var nextCharIndex = charIndex + node.length;
            if (!foundStart && savedSel.start >= charIndex && savedSel.start <= nextCharIndex)
            {
                range.setStart(node, savedSel.start - charIndex);
                foundStart = true;
            }
            if (foundStart && savedSel.end >= charIndex && savedSel.end <= nextCharIndex)
            {
                range.setEnd(node, savedSel.end - charIndex);
                stop = true;
            }
            charIndex = nextCharIndex;
        } else {
            var i = node.childNodes.length;
            while (i--)
            {
                nodeStack.push(node.childNodes[i]);
            }
        }
    }

    var sel = win.getSelection();
    sel.removeAllRanges();
    sel.addRange(range);
}
